package com.aiosman.riderpro.ui.index.tabs.search

import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.setValue
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import androidx.paging.Pager
import androidx.paging.PagingConfig
import androidx.paging.PagingData
import androidx.paging.cachedIn
import com.aiosman.riderpro.entity.AccountPagingSource
import com.aiosman.riderpro.entity.AccountProfileEntity
import com.aiosman.riderpro.entity.MomentPagingSource
import com.aiosman.riderpro.entity.MomentRemoteDataSource
import com.aiosman.riderpro.data.MomentService
import com.aiosman.riderpro.entity.MomentServiceImpl
import com.aiosman.riderpro.data.UserServiceImpl
import com.aiosman.riderpro.entity.MomentEntity
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.asStateFlow
import kotlinx.coroutines.flow.collectLatest
import kotlinx.coroutines.launch

object SearchViewModel : ViewModel() {
    var searchText by mutableStateOf("")
    private val momentService: MomentService = MomentServiceImpl()
    private val _momentsFlow = MutableStateFlow<PagingData<MomentEntity>>(PagingData.empty())
    val momentsFlow = _momentsFlow.asStateFlow()

    private val userService = UserServiceImpl()
    private val _usersFlow = MutableStateFlow<PagingData<AccountProfileEntity>>(PagingData.empty())
    val usersFlow = _usersFlow.asStateFlow()
    var showResult by mutableStateOf(false)
    fun search() {
        viewModelScope.launch {
            Pager(
                config = PagingConfig(pageSize = 5, enablePlaceholders = false),
                pagingSourceFactory = {
                    MomentPagingSource(
                        MomentRemoteDataSource(momentService),
                        contentSearch = searchText
                    )
                }
            ).flow.cachedIn(viewModelScope).collectLatest {
                _momentsFlow.value = it
            }
        }
        viewModelScope.launch {
            Pager(
                config = PagingConfig(pageSize = 5, enablePlaceholders = false),
                pagingSourceFactory = {
                    AccountPagingSource(
                        userService,
                        nickname = searchText
                    )
                }
            ).flow.cachedIn(viewModelScope).collectLatest {
                _usersFlow.value = it
            }
        }
        showResult = true
    }
}